uniform float	uniAmbientLight,
				uniDiffuseLight,
				uniSpecularLight;
				
in mat4			atrModelViewProjectionMatrix;
in vec3			atrDiffuseEvaluator,
				atrSpecularEvaluator;
in vec3			atrPosition;
in vec2			atrTextureCoordinates;
in vec4			atrColor;			//	premultiplied alpha

out vec2		varTextureCoordinates;
out vec4		varUnmaskedColor;	//	premultiplied alpha


void main()
{
	float	tmpDiffuseFactor,
			tmpSpecularFactor;

	gl_Position = atrModelViewProjectionMatrix * vec4(atrPosition, 1.0);

	varTextureCoordinates = atrTextureCoordinates;

	//	This shader gets used in the spherical case only.
	//	The position vector serves as the normal vector.
	tmpDiffuseFactor	= uniAmbientLight + uniDiffuseLight * max(0.0, dot(atrDiffuseEvaluator, atrPosition));
	tmpSpecularFactor	= uniSpecularLight * pow(max(0.0, dot(atrSpecularEvaluator, atrPosition)), 64.0);

	//	Compute the final unmasked color.
	varUnmaskedColor = min(	atrColor * vec4(tmpDiffuseFactor, tmpDiffuseFactor, tmpDiffuseFactor, 1.0)
							  + vec4(tmpSpecularFactor, tmpSpecularFactor, tmpSpecularFactor, tmpSpecularFactor),
							  1.0);
}
